'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _utils = require('./utils.js');

var _DefaultTemplate2 = require('./DefaultTemplate.js');

var _DefaultTemplate3 = _interopRequireDefault(_DefaultTemplate2);

var _MatchFragment = require('./MatchFragment.js');

var _MatchFragment2 = _interopRequireDefault(_MatchFragment);

var _PathComponent = require('./PathComponent.js');

var _PathComponent2 = _interopRequireDefault(_PathComponent);

var _RouterError = require('./RouterError.js');

var _RouterError2 = _interopRequireDefault(_RouterError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ConstPathTemplate = function (_DefaultTemplate) {
    _inherits(ConstPathTemplate, _DefaultTemplate);

    function ConstPathTemplate(templateUri, routeParams) {
        _classCallCheck(this, ConstPathTemplate);

        var _this = _possibleConstructorReturn(this, (ConstPathTemplate.__proto__ || Object.getPrototypeOf(ConstPathTemplate)).apply(this, arguments));

        var matchArray = [];
        var generateArray = [];
        var templateUriPath = templateUri.getParsedUri(_this._partName);
        var templateUriPathComponents = templateUriPath.toArray().map(function (value) {
            return new _PathComponent2.default(value);
        });
        var optionalPathParamNames = [];

        for (var t = 0, tl = templateUriPathComponents.length; t < tl; t++) {
            var matchFunctions = [];
            var generateFunctions = [];

            var templateUriPathComponent = templateUriPathComponents[t];
            var pathParamMatch = templateUriPathComponent.toString().match((0, _utils.getRegExp)('param'));
            if (pathParamMatch) {
                var pathParamName = pathParamMatch[1];
                var pathParamValue = routeParams.getParam(pathParamName);
                matchFunctions = _this._getParamMatchFunctions(pathParamName, pathParamValue);
                generateFunctions = _this._getParamGenerateFunctions(pathParamName, pathParamValue);
                generateFunctions.paramName = pathParamName;
                var isPathParamOptional = pathParamMatch[2] === '*';
                if (isPathParamOptional) {
                    optionalPathParamNames.push(pathParamName);
                    matchFunctions.optionalIndex = optionalPathParamNames.length;
                    generateFunctions.optionalIndex = optionalPathParamNames.length;
                }
            } else {
                matchFunctions = _this._getConstMatchFunctions(templateUriPathComponent);
                generateFunctions = _this._getConstGenerateFunctions(templateUriPathComponent);
            }

            matchArray[t] = matchFunctions;
            generateArray[t] = generateFunctions;
        }

        _this._matchArray = matchArray;
        _this._generateArray = generateArray;
        _this._optionalPathParamNames = optionalPathParamNames;
        return _this;
    }

    _createClass(ConstPathTemplate, [{
        key: 'matchParsedValue',
        value: function matchParsedValue(userUri, contextOptions) {
            var partName = contextOptions.partName;

            var optionalPathParamNames = this._optionalPathParamNames;
            var userUriPath = userUri.getParsedUri(partName);
            var templateUriPath = this._templateUri.getParsedUri(partName);

            if (!userUriPath.isAbsolute()) {
                throw new _RouterError2.default(_RouterError2.default.ABSOLUTE_PATH_EXPECTED, {
                    currentPath: userUriPath.toString()
                });
            }

            if (contextOptions.trailingSlashSensitive && userUriPath.hasTrailingSlash() !== templateUriPath.hasTrailingSlash()) {
                return null;
            }

            var userUriPathComponentCount = userUriPath.toArray().length;
            var templateUriPathComponentCount = templateUriPath.toArray().length;
            if (userUriPathComponentCount < templateUriPathComponentCount - optionalPathParamNames.length) {
                return null;
            }
            if (templateUriPath.isAbsolute() && userUriPathComponentCount > templateUriPathComponentCount) {
                return null;
            }

            var matchArray = this._matchArray;
            var value = userUri.getParsedUri(partName).toString();

            optionalLoop: for (var o = 0, ol = Math.pow(2, optionalPathParamNames.length); o < ol; o++) {
                var params = {};
                var optionalOffset = 0;
                componentLoop: for (var m = 0, ml = matchArray.length; m < ml; m++) {
                    var matchIndex = templateUriPath.isAbsolute() ? m : ml - 1 - m;
                    var matchFunctions = matchArray[matchIndex];
                    if (matchFunctions.optionalIndex && o / Math.pow(2, optionalPathParamNames.length + 1 - matchFunctions.optionalIndex) % 1 >= 0.5) {
                        optionalOffset--;
                        if (templateUriPath.isAbsolute() && userUriPathComponentCount > templateUriPathComponentCount + optionalOffset) {
                            continue optionalLoop;
                        } else {
                            var optionalParamName = optionalPathParamNames[matchFunctions.optionalIndex - 1];
                            Object.assign(params, _defineProperty({}, optionalParamName, ''));
                            continue componentLoop;
                        }
                    }
                    this._currentPathComponentIndex = templateUriPath.isAbsolute() ? m + optionalOffset : userUriPathComponentCount - 1 - m - optionalOffset;
                    var pathMatchFragment = _get(ConstPathTemplate.prototype.__proto__ || Object.getPrototypeOf(ConstPathTemplate.prototype), 'matchParsedValue', this).call(this, userUri, contextOptions, matchFunctions);
                    if (!pathMatchFragment) {
                        continue optionalLoop;
                    }
                    Object.assign(params, pathMatchFragment.params);
                }
                return new _MatchFragment2.default(value, params);
            }
            return null;
        }
    }, {
        key: 'generateParsedValue',
        value: function generateParsedValue(userParams, contextOptions) {
            var partName = contextOptions.partName;

            var generateArray = this._generateArray;
            var templateUriPath = this._templateUri.getParsedUri(partName);
            var rawValue = [];

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = generateArray[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var generateFunctions = _step.value;

                    var pathComponent = _get(ConstPathTemplate.prototype.__proto__ || Object.getPrototypeOf(ConstPathTemplate.prototype), 'generateParsedValue', this).call(this, userParams, contextOptions, generateFunctions);
                    if (pathComponent.isEmpty() && generateFunctions.paramName) {
                        if (generateFunctions.optionalIndex) {
                            continue;
                        } else {
                            var paramName = generateFunctions.paramName;

                            var routeName = this._routeName;
                            throw new _RouterError2.default(_RouterError2.default.PATH_COMPONENT_EXPECTED, {
                                paramName: paramName,
                                routeName: routeName
                            });
                        }
                    }
                    rawValue.push(encodeURIComponent(pathComponent.toString()));
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            rawValue = rawValue.join('/');
            if (templateUriPath.isAbsolute()) {
                rawValue = '/' + rawValue;
            }
            if (templateUriPath.hasTrailingSlash()) {
                rawValue += '/';
            }

            var PartConstructor = (0, _utils.getPartConstructor)(partName);
            var parsedValue = new PartConstructor(rawValue);
            return parsedValue;
        }
    }, {
        key: '_getConstMatchFunctions',
        value: function _getConstMatchFunctions(templateUriPathComponent) {
            var _this2 = this;

            return [function (userUri, contextOptions) {
                var partName = contextOptions.partName;

                var templateUriPathComponentString = templateUriPathComponent.toLowerCase(!contextOptions.caseSensitive).toString();
                var userUriRawPathComponents = userUri.getParsedUri(partName).toArray();
                var userUriPathComponent = new _PathComponent2.default(userUriRawPathComponents[_this2._currentPathComponentIndex]);
                var userUriPathComponentString = userUriPathComponent.toLowerCase(!contextOptions.caseSensitive).toString();
                if (userUriPathComponentString === templateUriPathComponentString) {
                    return new _MatchFragment2.default(userUriPathComponentString);
                }
                return null;
            }];
        }
    }, {
        key: '_getConstGenerateFunctions',
        value: function _getConstGenerateFunctions(templateUriPathComponent) {
            return [function (userParams) {
                return templateUriPathComponent;
            }];
        }
    }, {
        key: '_getParamMatchFunctions',
        value: function _getParamMatchFunctions(paramName, paramValue) {
            var _this3 = this;

            var getUserUriPart = function getUserUriPart(userUri) {
                var userUriPath = userUri.getParsedUri('path');
                return new _PathComponent2.default(userUriPath.toArray()[_this3._currentPathComponentIndex]);
            };
            return (0, _utils.convertMatchItemsToFunctions)(paramValue.match, {
                partName: 'pathComponent',
                paramName: paramName,
                getUserUriPart: getUserUriPart
            });
        }
    }, {
        key: '_getParamGenerateFunctions',
        value: function _getParamGenerateFunctions(paramName, paramValue) {
            return (0, _utils.convertGenerateItemsToFunctions)(paramValue.generate, {
                partName: 'pathComponent',
                paramName: paramName
            });
        }
    }, {
        key: '_getPartName',
        value: function _getPartName() {
            return 'path';
        }
    }]);

    return ConstPathTemplate;
}(_DefaultTemplate3.default);

exports.default = ConstPathTemplate;