'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _utils = require('./utils.js');

var _DefaultTemplate2 = require('./DefaultTemplate.js');

var _DefaultTemplate3 = _interopRequireDefault(_DefaultTemplate2);

var _MatchFragment = require('./MatchFragment.js');

var _MatchFragment2 = _interopRequireDefault(_MatchFragment);

var _QueryComponent = require('./QueryComponent.js');

var _QueryComponent2 = _interopRequireDefault(_QueryComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ConstQueryTemplate = function (_DefaultTemplate) {
    _inherits(ConstQueryTemplate, _DefaultTemplate);

    function ConstQueryTemplate(templateUri, routeParams) {
        _classCallCheck(this, ConstQueryTemplate);

        var _this = _possibleConstructorReturn(this, (ConstQueryTemplate.__proto__ || Object.getPrototypeOf(ConstQueryTemplate)).apply(this, arguments));

        var matchObjects = { true: {}, false: {} };
        var generateObjects = { true: {}, false: {} };
        var templateUriQuery = templateUri.getParsedUri(_this._partName);
        var templateUriQueryObject = templateUriQuery.toObject();

        for (var templateUriQueryCoupleKey in templateUriQueryObject) {

            var templateUriQueryCoupleValue = templateUriQueryObject[templateUriQueryCoupleKey];
            var queryCoupleParsedValue = new _QueryComponent2.default(templateUriQueryCoupleValue);
            var queryParamMatch = queryCoupleParsedValue.toString().match((0, _utils.getRegExp)('param'));

            var _arr = [true, false];
            for (var _i = 0; _i < _arr.length; _i++) {
                var caseSensitive = _arr[_i];
                var queryCoupleKey = new _QueryComponent2.default(templateUriQueryCoupleKey).toLowerCase(!caseSensitive);
                var matchFunctions = void 0;
                var generateFunctions = void 0;
                if (queryParamMatch) {
                    var queryParamName = queryParamMatch[1];
                    var queryParamValue = routeParams.getParam(queryParamName);
                    matchFunctions = _this._getParamMatchFunctions(queryCoupleKey, queryParamName, queryParamValue);
                    generateFunctions = _this._getParamGenerateFunctions(queryCoupleKey, queryParamName, queryParamValue);
                    if (queryParamMatch[2] === '*') {
                        matchFunctions.isOptional = true;
                        generateFunctions.isOptional = true;
                    }
                } else {
                    matchFunctions = _this._getConstMatchFunctions(queryCoupleKey, queryCoupleParsedValue);
                    generateFunctions = _this._getConstGenerateFunctions(queryCoupleKey, queryCoupleParsedValue);
                }
                matchObjects[caseSensitive][queryCoupleKey] = matchFunctions;
                generateObjects[caseSensitive][queryCoupleKey] = generateFunctions;
            }
        }

        _this._matchObjects = matchObjects;
        _this._generateObjects = generateObjects;
        return _this;
    }

    _createClass(ConstQueryTemplate, [{
        key: 'matchParsedValue',
        value: function matchParsedValue(userUri, contextOptions) {
            var matchObject = this._matchObjects[!!contextOptions.caseSensitive];
            var value = userUri.getParsedUri('query').toObject();
            var params = {};

            this._currentUserUriQueryObject = userUri.getParsedUri('query').toLowerCase(!contextOptions.caseSensitive).toObject();

            for (var m in matchObject) {
                var matchFunctions = matchObject[m];
                var queryMatchFragment = _get(ConstQueryTemplate.prototype.__proto__ || Object.getPrototypeOf(ConstQueryTemplate.prototype), 'matchParsedValue', this).call(this, userUri, contextOptions, matchFunctions);
                if (queryMatchFragment) {
                    if (queryMatchFragment.value !== null || matchFunctions.isOptional) {
                        Object.assign(params, queryMatchFragment.params);
                        continue;
                    }
                }
                return null;
            }

            var matchFragment = new _MatchFragment2.default(value, params);
            return matchFragment;
        }
    }, {
        key: 'generateParsedValue',
        value: function generateParsedValue(userParams, contextOptions) {
            var partName = contextOptions.partName;

            var generateObject = this._generateObjects[!!contextOptions.caseSensitive];
            var rawValue = [];

            for (var g in generateObject) {
                var generateFunctions = generateObject[g];
                var queryCoupleParsedValue = _get(ConstQueryTemplate.prototype.__proto__ || Object.getPrototypeOf(ConstQueryTemplate.prototype), 'generateParsedValue', this).call(this, userParams, contextOptions, generateFunctions);
                if (generateFunctions.isOptional && queryCoupleParsedValue.isEmpty()) {
                    continue;
                }
                rawValue.push(encodeURIComponent(g) + '=' + encodeURIComponent(queryCoupleParsedValue.toString()));
            }

            rawValue = rawValue.join('&');
            var PartConstructor = (0, _utils.getPartConstructor)(partName);
            var parsedValue = new PartConstructor(rawValue);
            return parsedValue;
        }
    }, {
        key: '_getConstMatchFunctions',
        value: function _getConstMatchFunctions(queryCoupleKey, queryCoupleParsedValue) {
            var _this2 = this;

            return [function (userUri, contextOptions) {
                var userUriQueryObject = _this2._currentUserUriQueryObject;
                var userUriQueryCoupleParsedValue = new _QueryComponent2.default(userUriQueryObject[queryCoupleKey]);
                if (userUriQueryCoupleParsedValue.isEmpty()) {
                    return null;
                }
                var userUriQueryCoupleString = userUriQueryCoupleParsedValue.toLowerCase(!contextOptions.caseSensitive).toString();
                var queryCoupleString = queryCoupleParsedValue.toLowerCase(!contextOptions.caseSensitive).toString();
                if (userUriQueryCoupleString !== queryCoupleString) {
                    return null;
                }
                return new _MatchFragment2.default(userUriQueryCoupleParsedValue.toString());
            }];
        }
    }, {
        key: '_getConstGenerateFunctions',
        value: function _getConstGenerateFunctions(queryCoupleKey, queryCoupleParsedValue) {
            return [function (userParams) {
                return queryCoupleParsedValue;
            }];
        }
    }, {
        key: '_getParamMatchFunctions',
        value: function _getParamMatchFunctions(queryCoupleKey, paramName, paramValue) {
            var _this3 = this;

            var getUserUriPart = function getUserUriPart(userUri) {
                var userUriQueryObject = _this3._currentUserUriQueryObject;
                var userUriQueryCoupleParsedValue = new _QueryComponent2.default(userUriQueryObject[queryCoupleKey]);
                if (!paramValue.match.length && userUriQueryCoupleParsedValue.isEmpty()) {
                    userUriQueryCoupleParsedValue.toString = function () {
                        return null;
                    };
                }
                return userUriQueryCoupleParsedValue;
            };
            return (0, _utils.convertMatchItemsToFunctions)(paramValue.match, {
                partName: 'queryComponent',
                paramName: paramName,
                getUserUriPart: getUserUriPart
            });
        }
    }, {
        key: '_getParamGenerateFunctions',
        value: function _getParamGenerateFunctions(queryCoupleKey, paramName, paramValue) {
            return (0, _utils.convertGenerateItemsToFunctions)(paramValue.generate, {
                partName: 'queryComponent',
                paramName: paramName
            });
        }
    }, {
        key: '_getPartName',
        value: function _getPartName() {
            return 'query';
        }
    }]);

    return ConstQueryTemplate;
}(_DefaultTemplate3.default);

exports.default = ConstQueryTemplate;