'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _RouterError = require('./RouterError.js');

var _RouterError2 = _interopRequireDefault(_RouterError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var baseDefaultOptions = {
    caseSensitive: false,
    trailingSlashSensitive: false,
    dataConsistency: true
};

var Options = function () {
    function Options(rawOptions, errorData) {
        _classCallCheck(this, Options);

        rawOptions = rawOptions || {};
        if ((typeof rawOptions === 'undefined' ? 'undefined' : _typeof(rawOptions)) !== 'object') {
            this._handleTypeError(errorData);
        }

        for (var b in baseDefaultOptions) {
            Options.setBooleanOption(this, b, rawOptions, this._getDefaultOptions(), true);
        }
    }

    _createClass(Options, [{
        key: '_getDefaultOptions',
        value: function _getDefaultOptions() {
            return baseDefaultOptions;
        }
    }, {
        key: '_handleTypeError',
        value: function _handleTypeError(errorData) {
            throw new _RouterError2.default(_RouterError2.default.INVALID_INPUT_TYPE, Object.assign({
                entity: 'options',
                type: 'plain object'
            }, errorData));
        }
    }], [{
        key: 'setBooleanOption',
        value: function setBooleanOption(object, optionName, rawOptions, fallbackOptions) {
            if (!rawOptions.hasOwnProperty(optionName)) {
                rawOptions = fallbackOptions;
            }
            if (rawOptions.hasOwnProperty(optionName)) {
                object[optionName] = !!rawOptions[optionName];
            }
        }
    }]);

    return Options;
}();

exports.default = Options;