'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require('./utils.js');

var _DefaultTemplate2 = require('./DefaultTemplate.js');

var _DefaultTemplate3 = _interopRequireDefault(_DefaultTemplate2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getUserUriPart = function getUserUriPart(userUri, partName) {
    return userUri.getParsedUri(partName);
};

var ParamUniversalTemplate = function (_DefaultTemplate) {
    _inherits(ParamUniversalTemplate, _DefaultTemplate);

    function ParamUniversalTemplate(templateUri, routeParams) {
        _classCallCheck(this, ParamUniversalTemplate);

        var _this = _possibleConstructorReturn(this, (ParamUniversalTemplate.__proto__ || Object.getPrototypeOf(ParamUniversalTemplate)).apply(this, arguments));

        var rawTemplate = templateUri.getSplittedUri(_this._partName);
        var paramMatch = rawTemplate.match((0, _utils.getRegExp)('param'));
        _this._paramName = paramMatch[1];
        _this._paramValue = routeParams.getParam(_this._paramName);
        _this._initMatchGenerateFunctions.apply(_this, arguments);
        return _this;
    }

    _createClass(ParamUniversalTemplate, [{
        key: '_getMatchFunctions',
        value: function _getMatchFunctions(templateUri) {
            var partName = this._partName;
            var paramName = this._paramName;
            var paramValue = this._paramValue;

            return (0, _utils.convertMatchItemsToFunctions)(paramValue.match, {
                partName: partName,
                paramName: paramName,
                getUserUriPart: getUserUriPart
            });
        }
    }, {
        key: '_getGenerateFunctions',
        value: function _getGenerateFunctions(templateUri) {
            var partName = this._partName;
            var paramName = this._paramName;
            var paramValue = this._paramValue;

            return (0, _utils.convertGenerateItemsToFunctions)(paramValue.generate, {
                partName: partName,
                paramName: paramName
            });
        }
    }]);

    return ParamUniversalTemplate;
}(_DefaultTemplate3.default);

exports.default = ParamUniversalTemplate;