'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Part2 = require('./Part.js');

var _Part3 = _interopRequireDefault(_Part2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Path = function (_Part) {
    _inherits(Path, _Part);

    function Path(rawPath) {
        _classCallCheck(this, Path);

        var _this = _possibleConstructorReturn(this, (Path.__proto__ || Object.getPrototypeOf(Path)).call(this, rawPath));

        rawPath = _this._value;

        var isAbsolute = false;
        var hasTrailingSlash = false;
        var components = [];

        if (rawPath) {
            isAbsolute = rawPath[0] === '/';
            hasTrailingSlash = rawPath.length > 1 && rawPath[rawPath.length - 1] === '/';
            components = rawPath.split('/');
            components = components.slice(+isAbsolute, -hasTrailingSlash + components.length);
        }

        var depthLevel = 0;
        components = components.reverse().filter(function (component) {
            return component !== '.';
        }).filter(function (component) {
            if (component === '..') {
                depthLevel++;
                return false;
            }
            if (depthLevel === 0) {
                return true;
            }
            depthLevel = Math.max(depthLevel - 1, 0);
            return false;
        }).reverse().map(decodeURIComponent);

        _this._value = {
            isAbsolute: isAbsolute,
            hasTrailingSlash: hasTrailingSlash,
            rawPath: rawPath,
            components: components
        };
        return _this;
    }

    _createClass(Path, [{
        key: 'isAbsolute',
        value: function isAbsolute() {
            return this._value.isAbsolute;
        }
    }, {
        key: 'hasTrailingSlash',
        value: function hasTrailingSlash() {
            return this._value.hasTrailingSlash;
        }
    }, {
        key: 'isEmpty',
        value: function isEmpty() {
            return this._value.rawPath === null;
        }
    }, {
        key: 'toString',
        value: function toString() {
            var value = this._value;
            var rawPath = value.components.map(encodeURIComponent).join('/');
            if (value.isAbsolute) {
                rawPath = '/' + rawPath;
            }
            if (value.hasTrailingSlash) {
                rawPath += '/';
            }
            return rawPath;
        }
    }, {
        key: 'toArray',
        value: function toArray() {
            return this._value.components;
        }
    }, {
        key: 'toLowerCase',
        value: function toLowerCase() {
            return this;
        }
    }]);

    return Path;
}(_Part3.default);

exports.default = Path;