'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Part2 = require('./Part.js');

var _Part3 = _interopRequireDefault(_Part2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var keyToKey = function keyToKey(key) {
    return key;
};
var keyToLowerCase = function keyToLowerCase(key) {
    return key.toLowerCase();
};

var Query = function (_Part) {
    _inherits(Query, _Part);

    function Query(rawQuery) {
        _classCallCheck(this, Query);

        var _this = _possibleConstructorReturn(this, (Query.__proto__ || Object.getPrototypeOf(Query)).call(this, rawQuery));

        rawQuery = _this._value;

        var components = {};
        if (rawQuery) {
            var queryCouples = rawQuery.split('&');
            queryCouples.forEach(function (queryCouple) {
                var equalIndex = queryCouple.indexOf('=');
                if (equalIndex === -1) {
                    components[decodeURIComponent(queryCouple)] = '';
                } else {
                    var queryCoupleKey = decodeURIComponent(queryCouple.substr(0, equalIndex));
                    var queryCoupleValue = decodeURIComponent(queryCouple.substr(equalIndex + 1));
                    components[queryCoupleKey] = queryCoupleValue;
                }
            });
        }

        _this._value = {
            rawQuery: rawQuery,
            components: components
        };
        return _this;
    }

    _createClass(Query, [{
        key: 'isEmpty',
        value: function isEmpty() {
            return this._value.rawQuery === null;
        }
    }, {
        key: 'toString',
        value: function toString() {
            var transformKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : keyToKey;

            var components = this.toObject();
            var queryCouples = [];
            for (var c in components) {
                var queryCoupleKey = encodeURIComponent(transformKey(c));
                var queryCoupleValue = encodeURIComponent(components[c]);
                queryCouples.push(queryCoupleKey + '=' + queryCoupleValue);
            }
            var rawQuery = queryCouples.join('&');
            return rawQuery;
        }
    }, {
        key: 'toObject',
        value: function toObject() {
            return this._value.components;
        }
    }, {
        key: 'toLowerCase',
        value: function toLowerCase(condition) {
            if (!condition) {
                return this;
            }
            var PartConstructor = this.constructor;
            return new PartConstructor(this.toString(keyToLowerCase));
        }
    }]);

    return Query;
}(_Part3.default);

exports.default = Query;