'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require('./utils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var emptyMatchGenerate = {
    match: [],
    generate: []
};

var RouteParams = function () {
    function RouteParams(rawRouteParams) {
        _classCallCheck(this, RouteParams);

        var parsedParams = {};
        for (var r in rawRouteParams) {
            var rawRouteParam = rawRouteParams[r];
            if ((0, _utils.isMatchGenerate)(rawRouteParam)) {
                rawRouteParam.match = RouteParams.normalizeItems(rawRouteParam.match);
                rawRouteParam.generate = RouteParams.normalizeItems(rawRouteParam.generate);
            } else {
                rawRouteParam = {
                    match: RouteParams.normalizeItems(rawRouteParam),
                    generate: RouteParams.normalizeItems()
                };
            }
            if (rawRouteParam.match.length || rawRouteParam.generate.length) {
                if (!rawRouteParam.generate.length) {
                    rawRouteParam.generate = RouteParams.completeGenerateItems(rawRouteParam.match);
                }
                parsedParams[r] = rawRouteParam;
            }
        }

        this._parsedParams = parsedParams;
    }

    _createClass(RouteParams, [{
        key: 'getParam',
        value: function getParam(paramName) {
            return this._parsedParams[paramName] || emptyMatchGenerate;
        }
    }], [{
        key: 'completeGenerateItems',
        value: function completeGenerateItems(matchItems) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = matchItems[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var matchItem = _step.value;

                    if (typeof matchItem !== 'function' && matchItem instanceof RegExp === false) {
                        return [matchItem];
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return [];
        }
    }, {
        key: 'normalizeItems',
        value: function normalizeItems(rawRouteParamItems) {
            if (rawRouteParamItems instanceof Array) {
                var filteredRouteParamItems = rawRouteParamItems.filter(function (rawRouteParamItem) {
                    return !(0, _utils.isEmpty)(rawRouteParamItem);
                });
                if (filteredRouteParamItems.length) {
                    return filteredRouteParamItems;
                }
            } else if (!(0, _utils.isEmpty)(rawRouteParamItems)) {
                return [rawRouteParamItems];
            }
            return [];
        }
    }]);

    return RouteParams;
}();

exports.default = RouteParams;