'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require('./utils.js');

var _RouterOptions = require('./RouterOptions.js');

var _RouterOptions2 = _interopRequireDefault(_RouterOptions);

var _Route = require('./Route.js');

var _Route2 = _interopRequireDefault(_Route);

var _UserUri = require('./UserUri.js');

var _UserUri2 = _interopRequireDefault(_UserUri);

var _RouterError = require('./RouterError.js');

var _RouterError2 = _interopRequireDefault(_RouterError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RussianRouter = function () {
    function RussianRouter() {
        var rawRoutes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var rawOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, RussianRouter);

        if (typeof this.getDefaultPart !== 'function') {
            throw new _RouterError2.default(_RouterError2.default.INVALID_DEFAULT_GETTER);
        }

        this._parsedOptions = this._parseOptions(rawOptions);
        this._parsedRoutes = this._parseRoutes(rawRoutes);
    }

    _createClass(RussianRouter, [{
        key: 'destructor',
        value: function destructor() {}
    }, {
        key: 'generateUri',
        value: function generateUri(routeName) {
            var userParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
            var parsedRoutes = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this._parsedRoutes;

            var parsedRoute = parsedRoutes[routeName];
            if (!parsedRoute || !parsedRoute.canBeGenerated()) {
                throw new _RouterError2.default(_RouterError2.default.INVALID_ROUTE_NAME, {
                    desiredRouteName: routeName
                });
            }
            var contextOptions = { router: this };
            return parsedRoute.generateUri(userParams, contextOptions);
        }
    }, {
        key: 'matchUri',
        value: function matchUri(rawUri) {
            var parsedRoutes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this._parsedRoutes;

            var parsedOptions = this._parsedOptions;
            var matchObjects = [];
            var userUri = new _UserUri2.default(rawUri, { router: this });
            for (var p in parsedRoutes) {
                var contextOptions = { router: this };
                var parsedRoute = parsedRoutes[p];
                if (!parsedRoute.canBeMatched()) {
                    continue;
                }
                var matchObject = parsedRoute.matchUri(userUri, contextOptions);
                if (matchObject) {
                    matchObjects.push(matchObject);
                    if (parsedOptions.onlyRoute) {
                        break;
                    }
                }
            }
            return parsedOptions.processMatchObjects(matchObjects);
        }
    }, {
        key: 'resolveUri',
        value: function resolveUri(rawUri) {
            return rawUri;
        }
    }, {
        key: 'getDefaultPart',
        value: function getDefaultPart() {
            var workAroundSolutionForBabelBug = _utils.getDefaultPart;
            return workAroundSolutionForBabelBug.call.apply(workAroundSolutionForBabelBug, [this].concat(Array.prototype.slice.call(arguments)));
        }
    }, {
        key: 'getParsedRoutes',
        value: function getParsedRoutes() {
            return this._parsedRoutes;
        }
    }, {
        key: 'getParsedOptions',
        value: function getParsedOptions() {
            return this._parsedOptions;
        }
    }, {
        key: '_parseOptions',
        value: function _parseOptions(rawOptions) {
            return new _RouterOptions2.default(rawOptions);
        }
    }, {
        key: '_parseRoutes',
        value: function _parseRoutes(rawRoutes) {
            var parsedRoutes = {};
            for (var routeName in rawRoutes) {
                parsedRoutes[routeName] = new _Route2.default(routeName, rawRoutes[routeName]);
            }
            return parsedRoutes;
        }
    }]);

    return RussianRouter;
}();

exports.default = RussianRouter;