'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require('./utils.js');

var _Uri2 = require('./Uri.js');

var _Uri3 = _interopRequireDefault(_Uri2);

var _RouterError = require('./RouterError.js');

var _RouterError2 = _interopRequireDefault(_RouterError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TemplateUri = function (_Uri) {
    _inherits(TemplateUri, _Uri);

    function TemplateUri(rawUri, routeName) {
        _classCallCheck(this, TemplateUri);

        var _this = _possibleConstructorReturn(this, (TemplateUri.__proto__ || Object.getPrototypeOf(TemplateUri)).call(this, rawUri));

        _this._routeName = routeName;

        var parsedPathArray = _this._value.parsedUri.path.toArray();
        if (parsedPathArray.length > 1) {
            var emptyPathComponentIndex = parsedPathArray.findIndex(function (component) {
                return !component;
            });
            if (emptyPathComponentIndex !== -1) {
                throw new _RouterError2.default(_RouterError2.default.PATH_COMPONENT_EXPECTED, { routeName: routeName });
            }
        }
        return _this;
    }

    _createClass(TemplateUri, [{
        key: '_getRegExp',
        value: function _getRegExp() {
            return (0, _utils.getRegExp)('template');
        }
    }, {
        key: '_handleError',
        value: function _handleError(error) {
            var routeName = this._routeName;
            throw new _RouterError2.default(_RouterError2.default[error.code], {
                entity: 'URI template',
                routeName: routeName
            });
        }
    }]);

    return TemplateUri;
}(_Uri3.default);

exports.default = TemplateUri;