'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = require('./utils.js');

var _RouterError = require('./RouterError.js');

var _RouterError2 = _interopRequireDefault(_RouterError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Uri = function () {
    function Uri(rawUri) {
        _classCallCheck(this, Uri);

        var splittedUri = void 0;
        try {
            splittedUri = (0, _utils.splitUri)(rawUri, this._getRegExp());
        } catch (error) {
            this._handleError(error);
        }

        var parsedUri = {};
        (0, _utils.forEachPartName)(function (partName) {
            var PartConstructor = (0, _utils.getPartConstructor)(partName);
            parsedUri[partName] = new PartConstructor(splittedUri[partName]);
        });

        this._value = {
            rawUri: rawUri,
            splittedUri: splittedUri,
            parsedUri: parsedUri
        };
    }

    _createClass(Uri, [{
        key: 'getRawUri',
        value: function getRawUri() {
            return this._value.rawUri;
        }
    }, {
        key: 'getSplittedUri',
        value: function getSplittedUri(partName) {
            if (partName) {
                return this._value.splittedUri[partName];
            }
            return this._value.splittedUri;
        }
    }, {
        key: 'getParsedUri',
        value: function getParsedUri(partName) {
            if (partName) {
                return this._value.parsedUri[partName];
            }
            return this._value.parsedUri;
        }
    }, {
        key: '_getRegExp',
        value: function _getRegExp() {
            return (0, _utils.getRegExp)('uri');
        }
    }, {
        key: '_handleError',
        value: function _handleError(error) {
            throw new _RouterError2.default(_RouterError2.default[error.code], {
                entity: 'URI'
            });
        }
    }]);

    return Uri;
}();

exports.default = Uri;